// fNXComplex

#ifndef ___Class_Complex
#define ___Class_Complex

#include <iostream>

//===== fNX =====//
class Complex {
	double re;		// 
	double im;		// 

public:
	Complex(double r = 0, double i = 0) : re(r), im(i) { }	 // RXgN^

	double real() const { return re; }		// Ԃ
	double imag() const { return im; }		// Ԃ

	Complex operator+() const { return *this; }				 // P+Zq
	Complex operator-() const { return Complex(-re, -im); }	 // P-Zq

	//--- Zq+= ---//
	Complex& operator+=(const Complex& x) {
		re += x.re;
		im += x.im;
		return *this;
	}

	//--- Zq-= ---//
	Complex& operator-=(const Complex& x) {
		re -= x.re;
		im -= x.im;
		return *this;
	}

	//--- Zq== ---//
	friend bool operator==(const Complex& x, const Complex& y) {
		return x.re == y.re && x.im == y.im;
	}

	//--- Zq!= ---//
	friend bool operator!=(const Complex& x, const Complex& y) {
		return !(x == y);
	}

	//--- Q+ZqiComplex + Complexj---//
	friend Complex operator+(const Complex& x, const Complex& y) {
		return Complex(x.re + y.re, x.im + y.im);
	}

	//--- Q+Zqidouble + Complexj---//
	friend Complex operator+(double x, const Complex& y) {
		return Complex(x + y.re, y.im);
	}

	//--- Q+ZqiComplex + doublej---//
	friend Complex operator+(const Complex& x, double y) {
		return Complex(x.re + y, x.im);
	}
};

//--- o̓Xg[sx} ---//
inline std::ostream& operator<<(std::ostream& s, const Complex& x)
{
	return s << '(' << x.real() << ", " << x.imag() << ')';
}

#endif
